<template>
  <div class="">
   
    <point-chart ref="chart" :w =100 :h=20></point-chart>
    <!-- agentes x generacion  , random bias -->
      <div>
        <input type="range" v-model="nAgents"
         min="100" max="100000" value="1000" step="100">
        <label >agentes por generacion : {{nAgents}}</label>
        <br>
      </div>
      <div>
        <input type="range" v-model="rBias"
         min="0" max="1" value="0.1" step="0.01">
        <label for="">random bias : {{rBias}}</label>
        <br>
      </div>

   
    <input type="range" v-model="memoryDays"
         min="0" max="100" value="1" step="1">
    <label for="">memory Days : {{memoryDays}}</label>
    <br>
    
    <input type="range" v-model="agentsMoney"
         min="0" max="400" value="200" step="10">
    <label for="">agent monet : {{agentsMoney}}</label>
    <br>
    <button @click="play()">play</button>

    <button @click="pause()">pause</button>
    <button @click="restart()">restart</button>
    <!-- generacion mejor , peor , media  -->
    <h1>nGeneration : {{nGeneration}}</h1>
    <h1>bestPoints : {{bestPoints}}</h1>
    <h1>worst : {{worst}}</h1>
    <h1>media : {{media}}</h1>
    

  </div>
</template>

<script>
const DAYS = require('../assets/data/trainData.json').info;
const GeneticManager  = require("../js/GeneticManager.js");
const Agent = require("../js/Agent.js")
import pointChart from '../components/pointChart.vue'

export default {
  name: 'SimulationScreen',
  components:{
    pointChart

  },
  props: {


  },
  data(){
    return{
        memoryDays: 2,
        nAgents : 100,
        rBias : 0.02,
        agentsMoney:400,
        nGeneration : 0,
        bestPoints : 0,
        worst : 0,
        media : 0,
        interval : "",
        gManager : ""
    }
  },
  methods:{
    prepareData(memoryDays){
    const mD =  parseInt(memoryDays, 10);
      var data = [];
      const enterprise = DAYS[3];
      for (let i = 0; i < enterprise.length-mD-1; i++) {
        var lastDay = enterprise[i+mD+1];
        // var today = enterprise[i];
      
        // var lastCountDay =enterprise[i+mD];
        var x = i
        // var y = (lastDay.Close-lastDay.Open > 0)?-1:1; 
        var y = lastDay.Open  
        data.push({'x':x,'y':y})
        
      }
    
    this.$refs.chart.addData(data);
    console.log("Data Loaded");
},
play: function () {
  this.pause = false;
  
  if(this.nGeneration == 0)
    this.gManager = new GeneticManager(this.memoryDays,this.memoryDays,3,this.nAgents,this.agentsMoney);
  console.log("init manager");
  this.gManager.randomBias = this.rBias;
  while (!this.pause ){
     this.step(this.memoryDays,this.memoryDays);
      this.gManager.generateNextGen();
     this.nGeneration ++;
     if(this.nGeneration%10 == 0) this.pause = true;
  }
  console.log("finished");
},
pause: function () {
  this.pause = true;
},
restart: function () {
  this.nGeneration = 0;
  this.gManager = null;
   this.gManager = new GeneticManager(this.memoryDays,this.memoryDays,3,this.nAgents,this.agentsMoney);
},

step(dayIndex , memoryDays ){
  //console.log("step begined",dayIndex,DAYS[0].length);
  if(dayIndex<DAYS[0].length){
    const dayInput = DAYS[0].slice(dayIndex-memoryDays,dayIndex);
     let dayOpens =[];
     dayInput.forEach(day => {
       dayOpens.push(Number(day.Open));
     });
    this.gManager.execute(dayOpens);
    //
    this.step(++dayIndex,memoryDays);
  }
  else{
    //get the results of the generation
    const lastPrice = DAYS[0][DAYS[0].length-1].Close;
    console.log("stats of generation :",this.gManager.getStats(lastPrice));
  }
  
}

  },
  // on create
  mounted(){
    this.prepareData(3);

for (let h = 0; h < DAYS.length; h++) {
  const enterprise = DAYS[h];
  
      var price = enterprise[0].Open;
      var priceBase = enterprise[0].Open;
      var historic = []
      var up = true;
      var daysInRow = 0;

      for (let i = 0; i < enterprise.length; i++) {
        const day = enterprise[i];
        var increment  = day.Open > price;
        
        if(up == increment)
        {
          daysInRow++;
        }
        else{
          var percent = ((day.Open-priceBase) *100) / priceBase
          historic.push([daysInRow,priceBase,day.Open,percent,up? "up":"down"]);
          daysInRow=0;
          priceBase = day.Open;
          up = !up;
        }
        price = day.Open;
      }
      
      var records = [];
      
      for (let i = 0; i < 20; i++) {
        records[i] = [0,0];
      }
      for (let i = 0; i < historic.length; i++) {
        const e = historic[i];
        records[e[0]][0]++;
        records[e[0]][1] += 100/historic.length;
      }

      //console.table(records);

  }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

</style>
